// ConfigureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HDTVtoMPEG2.h"
#include "ConfigureDlg.h"

// CConfigureDlg dialog

IMPLEMENT_DYNAMIC(CConfigureDlg, CDialog)
CConfigureDlg::CConfigureDlg(CWnd* pParent /*=NULL*/, CString iniPath)
	: CDialog(CConfigureDlg::IDD, pParent)
	, m_iniPath(iniPath)
	, m_MinIncludeSize(0)
	, m_MinExcludeSize(0)

{
}

CConfigureDlg::~CConfigureDlg()
{
}

void CConfigureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PRESERVE_BIT_RATE, m_cPreserveBitRate);
	DDX_Control(pDX, IDC_CHANGE_VERTICAL_SIZE, m_cChangeVerticalSize);
	DDX_Control(pDX, IDC_TRI_EDIT, m_cTRIDirectoryBox);
	DDX_Control(pDX, IDC_CREATE_TRI_FILES, m_cCreateTRIFiles);
	DDX_Control(pDX, IDC_INCLUDE_BLACK_FRAMES, m_cIncludeBlackFrames);
	DDX_Control(pDX, IDC_TRI_BROWSE, m_cTRIBrowse);
	DDX_Control(pDX, IDC_60_SEC, m_c60Sec);
	DDX_Control(pDX, IDC_10_SEC, m_c10Sec);
}


BEGIN_MESSAGE_MAP(CConfigureDlg, CDialog)
	ON_BN_CLICKED(IDC_CONFIGURE_OK, OnBnClickedConfigureOK)
	ON_BN_CLICKED(IDC_CONFIGURE_CANCEL, OnBnClickedConfigureCancel)
	ON_BN_CLICKED(IDC_TRI_BROWSE, OnBnClickedTriBrowse)
	ON_LBN_SELCHANGE(IDC_MIN_INCLUDE, OnLbnSelchangeMinInclude)
	ON_LBN_SELCHANGE(IDC_MIN_EXCLUDE, OnLbnSelchangeMinExclude)
	ON_BN_CLICKED(IDC_CREATE_TRI_FILES, OnBnClickedCreateTriFiles)
END_MESSAGE_MAP()

// CConfigureDlg message handlers

BOOL CConfigureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// get the current ini dialog settings
	char temp[256];

	// Preserve Bit Rate
	GetPrivateProfileString( "Settings", "PreserveBitRate", "0", temp, 2, m_iniPath );
	if( temp[0] == '0' )
		m_cPreserveBitRate.SetCheck( BST_UNCHECKED );
	else
		m_cPreserveBitRate.SetCheck( BST_CHECKED );

	// change vertical_size_value
	GetPrivateProfileString( "Settings", "ChangeVerticalSize", "0", temp, 2, m_iniPath );
	if( temp[0] == '0' )
		m_cChangeVerticalSize.SetCheck( BST_UNCHECKED );
	else
		m_cChangeVerticalSize.SetCheck( BST_CHECKED );

	// Create TRI files
	GetPrivateProfileString( "Settings", "CreateTRIFiles", "1", temp, 2, m_iniPath );
	if( temp[0] == '0' )
		m_cCreateTRIFiles.SetCheck( BST_UNCHECKED );
	else
		m_cCreateTRIFiles.SetCheck( BST_CHECKED );

	OnBnClickedCreateTriFiles();

	// tri directory location
	GetPrivateProfileString( "Settings", "TRIOut", " ", m_TRIDirectory, 255, m_iniPath );
	m_cTRIDirectoryBox.SetWindowText( m_TRIDirectory );

	// Include black frames
	GetPrivateProfileString( "Settings", "IncludeBlackFrames", "0", temp, 2, m_iniPath );
	if( temp[0] == '0' )
		m_cIncludeBlackFrames.SetCheck( BST_UNCHECKED );
	else
		m_cIncludeBlackFrames.SetCheck( BST_CHECKED );

	// max seek size
	GetPrivateProfileString( "Settings", "MaxSeekSize", "60", temp, 5, m_iniPath );
	m_MaxSeekSize = atoi( temp );
	if( m_MaxSeekSize == 10 )
		m_c10Sec.SetCheck( BST_CHECKED );
	else // default
		m_c60Sec.SetCheck( BST_CHECKED );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CConfigureDlg::OnBnClickedConfigureOK()
{
	// update the ini file settings

	int state = 0;
	CString string;

	// Preserve Bit Rate
	state = m_cPreserveBitRate.GetCheck();
	if( BST_CHECKED == state  )
		WritePrivateProfileString( "Settings", "PreserveBitRate", "1", m_iniPath );
	else
		WritePrivateProfileString( "Settings", "PreserveBitRate", "0", m_iniPath );

	// change vertical_size_value
	state = m_cChangeVerticalSize.GetCheck();
	if( BST_CHECKED == state )
		WritePrivateProfileString( "Settings", "ChangeVerticalSize", "1", m_iniPath );
	else
		WritePrivateProfileString( "Settings", "ChangeVerticalSize", "0", m_iniPath );

	// Create TRI files
	state = m_cCreateTRIFiles.GetCheck();
	if( BST_CHECKED == state  )
		WritePrivateProfileString( "Settings", "CreateTRIFiles", "1", m_iniPath );
	else
		WritePrivateProfileString( "Settings", "CreateTRIFiles", "0", m_iniPath );

	// TRI file path
	WritePrivateProfileString( "Settings", "TRIOut", m_TRIDirectory, m_iniPath );

	// Include Black Frames
	state = m_cIncludeBlackFrames.GetCheck();
	if( BST_CHECKED == state )
		WritePrivateProfileString( "Settings", "IncludeBlackFrames", "1", m_iniPath );
	else
		WritePrivateProfileString( "Settings", "IncludeBlackFrames", "0", m_iniPath );

	// max seek size
	if( m_c10Sec.GetCheck() == BST_CHECKED )
		WritePrivateProfileString( "Settings", "MaxSeekSize", "10", m_iniPath );
	else if( m_c60Sec.GetCheck() == BST_CHECKED )
		WritePrivateProfileString( "Settings", "MaxSeekSize", "60", m_iniPath );
	else // default
		WritePrivateProfileString( "Settings", "MaxSeekSize", "60", m_iniPath );

	CDialog::OnOK();
}

void CConfigureDlg::OnBnClickedConfigureCancel()
{
	CDialog::OnCancel();
}

void CConfigureDlg::OnBnClickedCreateTriFiles()
{
	int state = m_cCreateTRIFiles.GetCheck();
	if( BST_CHECKED == state  )
	{	
		// disable the TRI entry and browse controls
		m_cTRIDirectoryBox.EnableWindow( TRUE );
		m_cTRIBrowse.EnableWindow( TRUE );
	}
	else
	{
		m_cTRIDirectoryBox.EnableWindow( FALSE );;
		m_cTRIBrowse.EnableWindow( FALSE );;
	}

}

void CConfigureDlg::OnLbnSelchangeMinInclude()
{
	UpdateData();
}

void CConfigureDlg::OnLbnSelchangeMinExclude()
{
	UpdateData();
}

static int CALLBACK BrowseDirectoryCallback( HWND hwnd,UINT uMsg,LPARAM lp, LPARAM pData ) 
{
   TCHAR szDir[MAX_PATH];
   
   switch(uMsg)
   {
      case BFFM_INITIALIZED: 
         // Set the current folder we set in guiBrowseFolder.
         if( GetCurrentDirectory(sizeof(szDir)/sizeof(TCHAR), szDir) )
            SendMessage( hwnd, BFFM_SETSELECTION, TRUE,(LPARAM)szDir );
         break;            

      case BFFM_SELCHANGED:
         // Set the status window to the currently selected path.
         if( SHGetPathFromIDList((LPITEMIDLIST) lp ,szDir) ) {
            SendMessage( hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir );
         }               
         break;

      default:
         break;         
   }
   return( 0 );
}

void CConfigureDlg::OnBnClickedTriBrowse() 
{
	BROWSEINFO    bi;
	LPITEMIDLIST  pidl;
	LPMALLOC      pSHMallocInterface;
	
	UpdateData( TRUE ); // pull data from the dialog
	
	// Set the current folder.
	if( m_TRIDirectory[0] != '\0' )
		SetCurrentDirectory( m_TRIDirectory );
	
	// Browse.
	if( SUCCEEDED(SHGetMalloc(&pSHMallocInterface)) ) 
	{
		ZeroMemory( &bi, sizeof(bi) );
		bi.hwndOwner = GetSafeHwnd();
		bi.pszDisplayName = 0;
		bi.lpszTitle = "Select TRI File Directory";
		bi.pidlRoot = NULL;
		bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
		bi.lpfn = BrowseDirectoryCallback;
		pidl = SHBrowseForFolder( &bi );
	
		if( pidl ) 
		{
			if( SHGetPathFromIDList(pidl, m_TRIDirectory ) )
				m_cTRIDirectoryBox.SetWindowText( m_TRIDirectory );

			pSHMallocInterface->Free( pidl );
			pSHMallocInterface->Release();

		}
	}
}

