#pragma once


// CDragAndDropListBox

class CDragAndDropListBox : public CListBox
{
	DECLARE_DYNAMIC(CDragAndDropListBox)

public:
	CDragAndDropListBox();
	virtual ~CDragAndDropListBox();
	int GetMoveToIndex(){ return m_MoveToIndex; }
	int GetMovingIndex(){ return m_MovingIndex; }
	int WasMouseDrag(){ return m_IsMouseDrag; }
	void AddFile( CString sFile );
	void ClearPathList();

	int OnToolHitTest(CPoint point, TOOLINFO * pTI) const;
	UINT ItemFromPoint2(CPoint pt, BOOL& bOutside) const;
	
	BOOL OnToolTipText( UINT id, NMHDR * pNMHDR, LRESULT * pResult );
	CString GetFullFileName( UINT id );

protected:
   afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
   afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
   afx_msg void OnMouseMove(UINT nFlags, CPoint point);
   afx_msg void OnTimer(UINT nIDEvent);
   virtual void PreSubclassWindow();

private:
   int   m_MovingIndex;
   int   m_MoveToIndex;
   BOOL  m_IsMouseDrag;
   BOOL  m_Captured;
   DWORD m_Interval;    //scroll speed when an item is dragged above or below the window
   CStringList m_PathList; // list of file paths for tool tips

   void InsertDraggedItem();
   void DoTheScrolling(CPoint Point,CRect ClientRect);
   void DrawTheLines(int Index);

   DECLARE_MESSAGE_MAP()
};


