// HDTVtoMPEG2Dlg.h : header file
//

#if !defined(AFX_HDTVTOMPEG2DLG_H__64B610BB_7926_442F_AF99_076C26AF3513__INCLUDED_)
#define AFX_HDTVTOMPEG2DLG_H__64B610BB_7926_442F_AF99_076C26AF3513__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ProgressDialog.h"

#include "bcdmux.h"
#include "afxcmn.h"
#include "CheckComboBox.h"
#include "DragAndDropListBox.h"

/////////////////////////////////////////////////////////////////////////////
// CHDTVtoMPEG2Dlg dialog

class CHDTVtoMPEG2Dlg : public CDialog
{
// Construction
public:
	CHDTVtoMPEG2Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CHDTVtoMPEG2Dlg)
	enum { IDD = IDD_HDTVTOMPEG2_DIALOG };
	CCheckComboBox m_ChannelCombo;
	CCheckComboBox m_PIDCombo;
	CComboBox	m_FiletypeCombo;
	CEdit	m_OutputFile;
	CEdit	m_Extension;
	CDragAndDropListBox	m_InputFiles;
	CString	m_AudioPIDStr;
	CString	m_VideoPIDStr;
	int		m_MaxFileSize;
	CSliderCtrl	m_TimeSlider;
	CSliderCtrl m_brightnessSlider;
	CSliderCtrl m_contrastSlider;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHDTVtoMPEG2Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	int m_VideoPID, m_AudioPID, m_PidType;

	bool m_bCancel;
	char m_OutputFileName[256];

	char m_ExtensionStr[32];
	char m_TRIDirectory[256];
	bool m_KeepNULLs;
	bool m_KeepPSIP;
	bool m_Clips;
	bool m_PreserveBitRate;
	bool m_CreateTRIFiles;
	bool m_IncludeBlackFrames;
	bool m_SetVerticalSizeTo1080;

	int m_Contrast;
	int m_Brightness;
	int m_MinIncludeSize;
	int m_MinExcludeSize;
	int m_MaxSeekSize;
	CString m_InputPath;

	// input file info
	TSFileList m_InputList;
	CString m_TRIFileName;

	// progress dialog
	CProgressDialog *m_ProgressDlg;
	bool m_ShowPreview;


	Filetype m_Filetype;

	// regions editor
	char m_CurrentFileFullName[256];
	__int64 m_CurrentFileOffset;

	int m_MaxRange;
	int m_CurPos;

	int m_currentGOPVidPid;
	__int64 m_currentGOPStart;
	__int64 m_currentGOPEnd;
	bool m_currentGOPEndValid;

	char m_CurrentTimeText[16];
	char m_CurrentSizeText[16];
	char m_IncludedTimeText[16];
	char m_IncludedSizeText[16];
	char m_TotalTimeText[16];
	char m_TotalSizeText[16];
	char *m_CurrentFileName;

	bool m_doPreview;
	bool m_doRegion;
	bool m_canLargePreview;
	int m_largePreviewSize;

	CRect m_previewRect;
	CRect m_regionRect;

	BITMAPINFOHEADER m_BMIH;

	pdlg_buffer *m_activeBuffer;
	pdlg_buffer m_pdlgBuffers[2];

	unsigned char *m_scanBufferX;
	unsigned char *m_scanBuffer;
	int m_scanBufferAlignment;
	__int64 m_scanBufferSizeX;
	__int64 m_scanBufferSize;
	__int64 m_scanBufferOffsetBytes;
	__int64 m_scanBufferUsedBytes;
	__int64 m_scanRange;
	// output tsi file
	CFile m_tsiFile;
	CFileException e;
	
	CWordArray *pPIDDeleteList; // list of "visiable" PIDs to be deleted, video, audio, null, psip
	CWordArray *pHiddenPidDeleteList; // list of "hidden" PIDs to be deleted, RRT, SST, EIT, ETT, etc
	CWordArray *pProgramMapPIDs; // list of PMT PIDs
	CWordArray *pPCRPIDs; // list of PCR PID's
	CPtrArray *m_pPidInfoList; // final list of all PIDs and attributes for Processing

	void SetUpScanBuffer(void);
	bool FillScanBuffer(__int64 start, __int64 end);
	void EmptyScanBuffer(void);
	__int64 FillBuffer(void *dest, __int64 start, __int64 bytes);

	void ConfigureRegionsUI();	// call when file list changes
	void UpdateRegionsUI(int code = 0, __int64 seekto = 0);		// call when slider position changes

	// channels
	#define MAXCHANNELS 16
	int m_NumChannels;
	ATSC_CHANNEL_INFO m_Channels[MAXCHANNELS];

	// UI helper pointers
	CButton *m_pCheckProgressImage;
	CWnd *m_pConvert;
	CWnd *m_pDelete;
	CWnd *m_pClear;
	CWnd *m_pChannel;
	CWnd *m_pTxtResolution;
	CWnd *m_pTxtAspectRatio;
	CWnd *m_pTxtFrameRate;
	CWnd *m_pTxtBitRate;
	CWnd *m_pCurrentTime;
	CWnd *m_pCurrentSize;
	CWnd *m_pIncludedTime;
	CWnd *m_pIncludedSize;
	CWnd *m_pTotalTime;
	CWnd *m_pTotalSize;
	CWnd *m_pCurrentFile;
	CWnd *m_pBeginInclude;
	CWnd *m_pBeginExclude;
	CWnd *m_pRemoveRegion;
	CWnd *m_pClearAllRegions;
	CWnd *m_pScan;
	CWnd *m_pPrevRegion;
	CWnd *m_pNextRegion;
	CWnd *m_pMoveRegionBack;
	CWnd *m_pMoveRegionForward;
	CWnd *m_pRegionSlider;
	CWnd *m_pSeekBegin;
	CWnd *m_pSeekBack3;
	CWnd *m_pSeekBack2;
	CWnd *m_pSeekBack1;
	CWnd *m_pSeekForward1;
	CWnd *m_pSeekForward2;
	CWnd *m_pSeekForward3;
	CWnd *m_pSeekEnd;
	CWnd *m_pPreviewFrame;
	CWnd *m_pRegionFrame;
	CWnd *m_pInputFiles;
	CWnd *m_pBrightnessSlider;
	CWnd *m_pContrastSlider;
	CWnd *m_pOutputFile;
	CWnd *m_pExtension;
	CWnd *m_pPidsCombo;
	CWnd *m_pMaxFileSize;
	CWnd *m_pVideoPID;
	CWnd *m_pAudioPID;
	CWnd *m_pCut;

	// public functions

	static unsigned int WINAPI StaticConvertThread(LPVOID data);
	void ConvertThread();

	static unsigned int WINAPI StaticScanThread(LPVOID data);
	void ScanThread();

	static bool CHDTVtoMPEG2Dlg::StaticConvertCallback(char* ifilename, char* ofilename,
		__int64 cur_total_pos, __int64 cur_total_in, __int64 total_in,
		__int64 cur_total_out, long timeDiscrepancy, void* data);

	bool CHDTVtoMPEG2Dlg::ConvertCallback(char* ifilename, char* ofilename,
		__int64 cur_total_pos, __int64 cur_total_in, __int64 total_in,
		__int64 cur_total_out, long timeDiscrepancy);

	void CHDTVtoMPEG2Dlg::ProcessCmdLine( CString sCmdLine );
	__int64 CHDTVtoMPEG2Dlg::GetFileByteSize( CString sFileName );


// Implementation
protected:
	HICON m_hIcon;

	void SetVisibleStates(void);

	void CreateOutputFilename(void);
	void RemoveOutputFilenameExtension(char *ext);
	void AddOutputFilenameExtension(char *ext);
	void AddFile(const char *fileName);
	void RefreshInputFiles();

	void SaveOutputFilePath(const char *fileName);

	void DrawPreview(void);
	void DrawRegions(__int64 marker = -1);

	void CreateTSIFileName( CString sName );
	void OpenTRIFile();
	void SaveRegionInfo();
	bool ProcessTRIFile( CString sPath );
	void GetConfigSettings();

	BOOL PreTranslateMessage( MSG *pMsg );

	// Generated message map functions
	//{{AFX_MSG(CHDTVtoMPEG2Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnAdd();
	afx_msg void OnClear();
	afx_msg void OnConvert();
	afx_msg void OnSelchangeChannel();
	afx_msg void OnSelchangeFiletype();
	afx_msg void OnChangeMaxFileSize();
	afx_msg void OnDelete();
	afx_msg void OnSelchangeInputfiles();
	afx_msg void OnCheckProgressImage();
	afx_msg void OnChangeExtension();
	afx_msg void OnRemoveRegion();
	afx_msg void OnBeginExclude();
	afx_msg void OnBeginInclude();
	afx_msg void OnPeekAtFile();
	afx_msg void OnClearAllRegions();
	afx_msg void OnSeekBegin();
	afx_msg void OnSeekBack3();
	afx_msg void OnSeekBack2();
	afx_msg void OnSeekBack1();
	afx_msg void OnSeekForward1();
	afx_msg void OnSeekForward2();
	afx_msg void OnSeekForward3();
	afx_msg void OnSeekEnd();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPrevRegion();
	afx_msg void OnNextRegion();
	afx_msg void OnMoveRegionBack();
	afx_msg void OnMoveRegionForward();
	afx_msg void OnScan();
	afx_msg void OnOutputfileBrowse();
	afx_msg BOOL OnMouseWheel( UINT nFlags, short zDelta, CPoint pt );
	afx_msg void OnChannelCheckBox();
	afx_msg void OnPidsCheckBox();
	afx_msg void OnBnClickedClips();
	afx_msg void OnBeginCut();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HDTVTOMPEG2DLG_H__64B610BB_7926_442F_AF99_076C26AF3513__INCLUDED_)
