// ProgressDialog.cpp : implementation file
//
// Changelog:
//
// 1.07 - 2-23-2002 - GR: Support for progress bar of total conversion.
//
// 1.10.4 - 5-02-2004 - CM: CDC resource leaks fixed(bug)
//

#include "stdafx.h"
#include "HDTVtoMPEG2.h"
#include "ProgressDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressDialog dialog

char CProgressDialog::m_Title[32];
char CProgressDialog::m_InputFileName[256];
char CProgressDialog::m_OutputFileName[256];
__int64 CProgressDialog::m_ProgressPos;
int CProgressDialog::m_ProgressTotalPos;

long CProgressDialog::m_lTimeStart;
float CProgressDialog::m_fTimeTaken;
char CProgressDialog::m_TimeTakenText[16];
char CProgressDialog::m_TimeToGoText[16];
char CProgressDialog::m_ConversionSpeedInText[16];
char CProgressDialog::m_ConversionSpeedOutText[16];
bool CProgressDialog::m_Finished;
CWnd *CProgressDialog::m_pOutputFileText;
CWnd *CProgressDialog::m_pToGoText;
CWnd *CProgressDialog::m_pTimeToGoText;

CProgressDialog::CProgressDialog(UINT nIDTemplate, CWnd* pParent /*=NULL*/)
	: CDialog(nIDTemplate, pParent)
{
	EnableAutomation();

	m_activeBuffer = NULL;
	m_pdlgBuffers = NULL;

	m_InputList = NULL;

	//{{AFX_DATA_INIT(CProgressDialog)
	//}}AFX_DATA_INIT
}


void CProgressDialog::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CProgressDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDialog)
	DDX_Control(pDX, IDC_OUTPUTFILE, m_OutputFile);
	DDX_Control(pDX, IDC_INPUTFILE, m_InputFile);
	DDX_Control(pDX, IDC_TIME_TAKEN, m_TimeTaken);
	DDX_Control(pDX, IDC_TIME_TO_GO, m_TimeToGo);
	DDX_Control(pDX, IDC_CONVERSION_SPEED_IN, m_ConversionSpeedIn);
	DDX_Control(pDX, IDC_CONVERSION_SPEED_OUT, m_ConversionSpeedOut);
	DDX_Control(pDX, IDC_PROGRESSTOTALBAR, m_ProgressTotalBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgressDialog, CDialog)
	//{{AFX_MSG_MAP(CProgressDialog)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CProgressDialog, CDialog)
	//{{AFX_DISPATCH_MAP(CProgressDialog)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IProgressDialog to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {269D387C-75C8-40D4-B253-8D505A36FF8B}
static const IID IID_IProgressDialog =
{ 0x269d387c, 0x75c8, 0x40d4, { 0xb2, 0x53, 0x8d, 0x50, 0x5a, 0x36, 0xff, 0x8b } };

BEGIN_INTERFACE_MAP(CProgressDialog, CDialog)
		INTERFACE_PART(CProgressDialog, IID_IProgressDialog, Dispatch)
END_INTERFACE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CProgressDialog message handlers

BOOL CProgressDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ProgressTotalBar.SetRange(0, 1000);

	m_Timer = SetTimer(0, 100, NULL);

	strcpy(m_Title, "0% Progress");
	m_InputFileName[0] = '\0';
	m_OutputFileName[0] = '\0';
	m_ProgressPos = 0;
	m_ProgressTotalPos = 0;

	m_TimeTakenText[0] = '\0';
	m_TimeToGoText[0] = '\0';
	m_ConversionSpeedInText[0] = '\0';
	m_ConversionSpeedOutText[0] = '\0';

	// init these two in calling thread
	// time(&m_lTimeStart);
	// m_fTimeTaken = 0.0f;

	m_Finished = false;

	// init bitmap stuff
	m_doPreview = false;
	CWnd *pr = GetDlgItem(IDC_PREVIEW_FRAME);
	if (pr && m_pdlgBuffers)
	{
		m_doPreview = true;

		pr->GetWindowRect(m_previewRect);
		ScreenToClient(m_previewRect);
	}

	if (m_pdlgBuffers)
	{
		m_BMIH.biSize = sizeof(BITMAPINFOHEADER);
		m_BMIH.biWidth = 240;	// oh look, a hard coded size
		m_BMIH.biHeight = 135;	// 240x135 = 1920x1080 / 8 (1 pixel per block)
		m_BMIH.biPlanes = 1;
		m_BMIH.biBitCount = 24;
		m_BMIH.biCompression = BI_RGB;
		m_BMIH.biXPelsPerMeter = 0;
		m_BMIH.biYPelsPerMeter = 0;
		m_BMIH.biClrUsed = 0;
		m_BMIH.biClrImportant = 0;

		DWORD dwBytes = ((DWORD) m_BMIH.biWidth * m_BMIH.biBitCount) / 32;
		if (((DWORD) m_BMIH.biWidth * m_BMIH.biBitCount) % 32)
			dwBytes++;
		dwBytes *= 4;
		m_BMIH.biSizeImage = 4 * dwBytes * m_BMIH.biHeight;

		// set up buffers if needed

		// if buffers already exists, are they the wrong size?
		if (m_pdlgBuffers[0].bm.buffer &&
				((m_pdlgBuffers[0].bm.width != (uint)m_BMIH.biWidth) ||
					(m_pdlgBuffers[0].bm.height != (uint)m_BMIH.biHeight)))
		{
			delete pdlg_buffers[0].bm.buffer;
			pdlg_buffers[0].bm.buffer = NULL;
		}

		if (m_pdlgBuffers[1].bm.buffer &&
				((m_pdlgBuffers[1].bm.width != (uint)m_BMIH.biWidth) ||
					(m_pdlgBuffers[1].bm.height != (uint)m_BMIH.biHeight)))
		{
			delete pdlg_buffers[1].bm.buffer;
			pdlg_buffers[1].bm.buffer = NULL;
		}

		// do we need to setup & allocate the buffers?
		if (!m_pdlgBuffers[0].bm.buffer)
		{
			m_pdlgBuffers[0].bm.width = m_BMIH.biWidth;
			m_pdlgBuffers[0].bm.height = m_BMIH.biHeight;
			m_pdlgBuffers[0].bm.stride = (m_BMIH.biWidth * m_BMIH.biBitCount)>>3;
			m_pdlgBuffers[0].bm.size = m_BMIH.biSizeImage;

			m_pdlgBuffers[0].bm.buffer = new uchar[m_BMIH.biSizeImage];
		}

		if (!m_pdlgBuffers[1].bm.buffer)
		{
			m_pdlgBuffers[1].bm.width = m_BMIH.biWidth;
			m_pdlgBuffers[1].bm.height = m_BMIH.biHeight;
			m_pdlgBuffers[1].bm.stride = (m_BMIH.biWidth * m_BMIH.biBitCount)>>3;
			m_pdlgBuffers[1].bm.size = m_BMIH.biSizeImage;

			m_pdlgBuffers[1].bm.buffer = new uchar[m_BMIH.biSizeImage];
		}

		if (m_pdlgBuffers[0].bm.buffer && m_pdlgBuffers[1].bm.buffer)
		{
			// clear the buffers
			memset(m_pdlgBuffers[0].bm.buffer, 0, m_BMIH.biSizeImage);
			memset(m_pdlgBuffers[1].bm.buffer, 0, m_BMIH.biSizeImage);

			// tag them as available to the conversion thread
			m_pdlgBuffers[0].rendered = 0;
			m_pdlgBuffers[1].rendered = 0;
		}
		else
		{
			m_doPreview = false;
		}

		m_activeBuffer = NULL;
	}

	m_doRegion = false;
	pr = GetDlgItem(IDC_REGION_FRAME);
	if (pr)
	{
		m_doRegion = true;

		pr->GetWindowRect(m_regionRect);
		ScreenToClient(m_regionRect);
	}
	m_DrawnRegionMarker = -1;

	SetWindowText(m_Title);

	m_pOutputFileText = GetDlgItem( IDC_OUTPUTFILETEXT );
	m_pToGoText = GetDlgItem( IDC_TOGO_TEXT );
	m_pTimeToGoText = GetDlgItem( IDC_TIME_TO_GO );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CProgressDialog::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CProgressDialog::OnTimer(UINT nIDEvent) 
{
	char buf[256];
	int progress;

	if (m_Finished)
		EndDialog(IDCANCEL);

	GetWindowText(buf, 255);
	if (strcmp(buf, m_Title) != 0)
		SetWindowText(m_Title);

	m_InputFile.GetWindowText(buf, 31);
	if (strcmp(buf, m_InputFileName) != 0)
		m_InputFile.SetWindowText(m_InputFileName);

	m_OutputFile.GetWindowText(buf, 255);
	if (strcmp(buf, m_OutputFileName) != 0)
		m_OutputFile.SetWindowText(m_OutputFileName);

	if (m_DrawnRegionMarker != m_ProgressPos)
		DrawRegions(m_ProgressPos);
	
	progress = m_ProgressTotalBar.GetPos();
	if (progress != m_ProgressTotalPos)
		m_ProgressTotalBar.SetPos(m_ProgressTotalPos);
	
	m_TimeTaken.GetWindowText(buf, 255);
	if (strcmp(buf, m_TimeTakenText) != 0)
		m_TimeTaken.SetWindowText(m_TimeTakenText);

	m_TimeToGo.GetWindowText(buf, 255);
	if (strcmp(buf, m_TimeToGoText) != 0)
		m_TimeToGo.SetWindowText(m_TimeToGoText);

	m_ConversionSpeedIn.GetWindowText(buf, 255);
	if (strcmp(buf, m_ConversionSpeedInText) != 0)
		m_ConversionSpeedIn.SetWindowText(m_ConversionSpeedInText);

	m_ConversionSpeedOut.GetWindowText(buf, 255);
	if (strcmp(buf, m_ConversionSpeedOutText) != 0)
		m_ConversionSpeedOut.SetWindowText(m_ConversionSpeedOutText);

	if (m_doPreview)
	{
		// fairly hack-like way of swapping buffers with other thread
		if (!m_activeBuffer)
		{
			if ((m_pdlgBuffers[0].rendered > 0) && m_pdlgBuffers[0].bm.buffer)
			{
				if ((m_pdlgBuffers[1].rendered > 0) && m_pdlgBuffers[1].bm.buffer)
				{
					if (m_pdlgBuffers[0].rendered < m_pdlgBuffers[1].rendered)
						m_activeBuffer = &m_pdlgBuffers[0];
					else
						m_activeBuffer = &m_pdlgBuffers[1];
				}
				else
					m_activeBuffer = &m_pdlgBuffers[0];
			}
			else if ((m_pdlgBuffers[1].rendered > 0) && m_pdlgBuffers[1].bm.buffer)
				m_activeBuffer = &m_pdlgBuffers[1];

			if (m_activeBuffer)
			{
				// buffer is OK to draw!
				DrawPreview();
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CProgressDialog::OnPaint() 
{
	DrawPreview();
	DrawRegions();

	CDialog::OnPaint();
}

void CProgressDialog::DrawPreview(void)
{
	if (m_doPreview && m_activeBuffer)
	{
		CDC *pDC = GetDC();

		// do a stretch according to aspect ratio

		// note: m_previewRect is placed in the dialog to be as close as
		// possible to 135 pixels in height (which is 1080 / 8)
		// and the width is large enough to cope with the 2.21 ratio

		float widthRatio = 16.0f/9.0f;	// default
		switch (m_activeBuffer->aspectRatio)
		{
		case 1: widthRatio = 1.0f/1.0f; break;
		case 2: widthRatio = 4.0f/3.0f; break;
		case 3: widthRatio = 16.0f/9.0f; break;
		case 4: widthRatio = 2.21f/1.0f; break;
		}

		int height = 135;	//m_previewRect.Height();
		int width = (int)((float)height * widthRatio);
		//	calculate appropriate top left
		int left = m_previewRect.left + ((m_previewRect.Width() - width)>>1);
		int top = m_previewRect.top;// + ((m_previewRect.Height() - m_activeBuffer->bm.height)>>1);

		pDC->SetStretchBltMode(COLORONCOLOR);
		StretchDIBits(pDC->GetSafeHdc(), left, top, width, height,
			0, m_activeBuffer->bm.height-m_activeBuffer->renderedHeight, m_activeBuffer->renderedWidth, m_activeBuffer->renderedHeight,
			m_activeBuffer->bm.buffer, (LPBITMAPINFO) &m_BMIH, DIB_RGB_COLORS, SRCCOPY);

		// make buffer available for refilling by conversion thread
		m_activeBuffer->rendered = 0;
		m_activeBuffer = NULL;

		ReleaseDC( pDC );
	}
}

void CProgressDialog::DrawRegions(__int64 marker)
{
	// draw regions bar
	if (m_doRegion && m_InputList)
	{
		// grab critical section to prevent other threads messing with the
		// input file list while we're drawing it.
		m_InputList->Lock();

		TSFileInfo *ti = m_InputList->GetHead();
		if (ti)
		{
			CDC *pDC = GetDC();

			CRect r;	// Include/Exclude bar
			CRect r2;	// Include/Exclude marker
			CRect r3;	// Cut marker
			r = m_regionRect;
			r2 = r;
			r3 = r;
			r2.bottom = r2.top + (r2.Height()*2)/3;

			int zeroLeft = r.left;
			int totalWidth = m_regionRect.Width();

			int fileCount = 0;
			RegionType rt = rt_include;
			while (ti)
			{
				int level = 255;
				if ((fileCount++)%2)
					level = 200;

				TSRegionInfo *tri = ti->m_head;

				r.left = zeroLeft + int((__int64(totalWidth) * ti->m_totalBytesPrior) / m_InputList->TotalBytes());
				if (tri)
					r.right = zeroLeft + int((__int64(totalWidth) * (ti->m_totalBytesPrior + tri->m_offset)) / m_InputList->TotalBytes());
				else
					r.right = zeroLeft + int((__int64(totalWidth) * (ti->m_totalBytesPrior + ti->m_fileSize)) / m_InputList->TotalBytes());

				COLORREF cr;
				if( rt == rt_include || rt == rt_cut )
					cr = RGB(0,level,0);
				else
					cr = RGB(level,0,0);

				pDC->FillSolidRect(r, cr);
					
				while (tri)
				{
					r.left = r.right;
					if (tri->m_next)
						r.right = zeroLeft + int((__int64(totalWidth) * (ti->m_totalBytesPrior + tri->m_next->m_offset)) / m_InputList->TotalBytes());
					else
						r.right = zeroLeft + int((__int64(totalWidth) * (ti->m_totalBytesPrior + ti->m_fileSize)) / m_InputList->TotalBytes());

					rt = tri->m_type;

					COLORREF cr;
					if( rt == rt_include || rt == rt_cut )
						cr = RGB(0,level,0);
					else
						cr = RGB(level,0,0);
/*
					else if( rt == rt_exclude )
						cr = RGB(level,0,0);
					else
					{

						TSRegionInfo *t = tri;
						RegionType rType;

						while( t != NULL && t->m_type == rt_cut )
							t = t->m_prev;

						if( t == NULL )
							rType = rt_include;
						else
							rType = t->m_type;

						if( rType == rt_include )
							cr = RGB( 0, level, 0 );
						else
							cr = RGB( level, 0, 0 );
					}
*/

					if( rt != rt_cut )
					{
						pDC->FillSolidRect(r, cr);

						r2.left = r.left;
						r2.right = r2.left +1;

						pDC->FillSolidRect(r2, 0);
					}
					else
					{
						// draw the "cut" marker
						r3.left = r.left;
						r3.right = r3.left + 1;
						pDC->FillSolidRect( r3, RGB(0, 0, level));

						// draw the rest of the green\red color bar
						r.left += 1;
						pDC->FillSolidRect(r, cr);
					}

					tri = tri->m_next;
				}

				ti = ti->m_next;
			}

			if (marker >= 0)
			{
				r.left = zeroLeft + int((__int64(totalWidth) * marker) / m_InputList->TotalBytes());
				r.right = r.left + 1;

				pDC->FillSolidRect(r, RGB(0,0,255));
			}
			m_DrawnRegionMarker = marker;

			ReleaseDC( pDC );
		}

		m_InputList->Unlock();
	}
}
