/********************************************************************/
/*THIS SAMPLE CODE IS PROVIDED "AS IS" WITH NO WARRANTIES			*/
/*WHATSOEVER, INCLUDING ANY WARRANTY OF MERCHANTABILITY, 			*/
/*NONINFRINGEMENT, FITNESS FOR ANY PARTICULAR PURPOSE, OR ANY 		*/
/*WARRANTY OTHERWISE ARISING OUT OF THIS SAMPLE.					*/
/********************************************************************/
/*            Copyright (c) 1999 - 2000 Intel Corporation.			*/
/*                     All rights reserved.							*/
/********************************************************************/

#ifndef __IDCT_H
#define __IDCT_H

typedef short int16;
#define DEFAULT_8X8_BLOCK 64
// number of iterations
#define N 1000

#define pi		3.14159265358979323846

#define ONE	((int) 1)
#define LG2_DCT_SCALE 15	
#define DCT_SCALE (ONE << LG2_DCT_SCALE)

#define BITS_INV_ACC	4                                // 4 or 5 for IEEE
#define SHIFT_INV_ROW	16 - BITS_INV_ACC
#define SHIFT_INV_COL	1 + BITS_INV_ACC
const short RND_INV_ROW   = 1024 * (6 - BITS_INV_ACC);        //1 << (SHIFT_INV_ROW-1)
const short RND_INV_COL   = 16 * (BITS_INV_ACC - 3);          // 1 << (SHIFT_INV_COL-1)
const short RND_INV_CORR  = RND_INV_COL - 1;                  // correction -1.0 and round


#define M128IVEC_IDCT	"M128_Ivec_IDCT"
#define M128ASM_IDCT	"M128_asm_IDCT"
#define M64ASM_IDCT		"M64_ASM_IDCT"
#define C_IDCT			"C_IDCT"

#define PRIORITY_IN_VEC_COUNT   MAX_PRIORITY
#define SZ_ABBREV_IN_VEC_COUNT  "vec"
#define SZ_BRIEF_IN_VEC_COUNT   "[/vec n]"
#define SZ_VERBOSE_IN_VEC_COUNT "vec        set the number of vectors to perform dot product on\n" \
                                "           n - number of vectors\n"
#ifdef GBV
struct ieee {
			double ppe;		/* pixel peak error */		/* any pixel */
			double pmse[64];	/* pixel mean square error */	/* any pixel */
			double omse;		/* overall mean square error */	/* overall */
			double pme[64];	/* pixel mean error */		/* any pixel */
			double ome;		/* overall mean error */	/* overall */
			} standard;
#else
	extern struct ieee {
				double ppe;		/* pixel peak error */		/* any pixel */
				double pmse[64];	/* pixel mean square error */	/* any pixel */
				double omse;		/* overall mean square error */	/* overall */
				double pme[64];	/* pixel mean error */		/* any pixel */
				double ome;		/* overall mean error */	/* overall */
				} standard;
#endif

/****************************************************************************/
class idct
{
public:
	virtual int transform(short *src, short *dst) = 0;
};


/****************************************************************************/
class idct_M64ASM : public idct
{
public:

    //////////////////////////////////////////////////////////////////////////
	virtual int transform(short *src, short *dst);
};

/****************************************************************************/
class idct_M128ASM : public idct
{
public:

    //////////////////////////////////////////////////////////////////////////
	virtual int transform(short *src, short *dst);
};

/****************************************************************************/
class idct_M128IVEC : public idct
{
public:

    //////////////////////////////////////////////////////////////////////////
	virtual int transform(short *src1, short *dst1);
};


#endif __DOT_PRODUCT_H